#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> G (1e3*1e2+1e2+15);

vector<vector<int>> ops (1e3+15);
vector<int> pos(1e3+15);
vector<int> wait_recv(1e3+15, -1);
vector<int> wait_send(1e3+15, -1);

void process_ops(int u) {
    stack<int> S;
    S.push(u);

    while (!S.empty()) {
        int u = S.top(); S.pop();
        while (pos[u] < ops[u].size()) {
            int op = ops[u][pos[u]];
            pos[u]++;

            if (op > 0) {
                op--;
                if (wait_recv[op] == u) {
                    G[1e2*u + pos[u]-1].push_back(1e2*op + pos[op]-1);
                    wait_recv[op] = -1;
                } else {
                    wait_send[u] = op;
                    S.push(u);
                    S.push(op);
                    break;
                }
            } else if (op < 0) {
                op = -op;
                op--;
                if (wait_send[op] == u) {
                    G[1e2*op + pos[op]-1].push_back(1e2*u + pos[u]-1);
                    wait_send[op] = -1;
                } else {
                    wait_recv[u] = op;
                    S.push(u);
                    S.push(op);
                    break;
                }
            }
        }
    }
}

vector<int> visited(1e3*1e2+1e2+15);

bool dfs(int u, int target) {
    stack<int> S;

    fill(visited.begin(), visited.end(), 0);
    S.push(u);
    while (!S.empty()) {
        int u = S.top(); S.pop();
        if (visited[u]) { continue; }
        visited[u] = true;
        if (u == target) { return true; }

        for (int v : G[u]) { S.push(v); }
    }

    return false;
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;

    for (int u = 0; u < n; u++) {
        int m;
        cin >> m;

        vector<int> op (m);
        for (int j = 0; j < m; j++) {
            cin >> op[j];
            if (j != m-1) {
                G[1e2*u+j].push_back(1e2*u+j+1);
            }
        }
        ops[u] = op;
    }

    for (int u = 0; u < n; u++) { process_ops(u); }

    int q;
    cin >> q;

    while (q--) {
        int u, i;
        cin >> u >> i;
        u--; i--;
        int v, j;
        cin >> v >> j;
        v--; j--;

        if (dfs(1e2*u + i, 1e2*v + j)) {
            cout << "<\n";
        } else if (dfs(1e2*v + j, 1e2*u + i)) {
            cout << ">\n";
        } else {
            cout << "?\n";
        }
    }
}
